
open Arg

open Utils
open Types
open Expr.StdExpression


module type ClassicalReachabilityAnalysis = 
sig
  module Configuration : 
  sig
    val argument_specification : Configuration.t -> (key * spec * doc) list
    val default_configuration : Configuration.values
  end

  type ('s,'t,'p) input = ('s, 't*guard*(command list), 'p) LabeledTransitionSystem.t

  val run_and_print :
    Utils.Configuration.t ->
    ('s,'t,'p) input ->
    's printer -> 
    't printer ->
    'p printer ->
    Format.formatter ->
    unit
end


module ZonesReachability : ClassicalReachabilityAnalysis
module MultisetReachability : ClassicalReachabilityAnalysis

