

(* Raised by the lexer then LexingError is re-raised *)
exception Lex_error of Lexing.lexbuf * string

(* Replace by Parsing.new_line for ocaml 3.11 *)
val lex_eol : Lexing.lexbuf -> unit

type 'token lexer_type = Lexing.lexbuf -> 'token
type ('ast,'token) parser_type = ('token lexer_type) -> Lexing.lexbuf -> 'ast

module type ParsingFunctions =
sig
  type ast
  type token

  val the_lexer : token lexer_type
  val the_parser : (ast,token) parser_type
end


module MakeParser (F : ParsingFunctions) :
sig
  val parse_lexbuf : Lexing.lexbuf -> F.ast
  val parse_string : string -> F.ast
  val parse_file : string -> F.ast
end
