
(* Exceptions *)

type error_comment = string
type error_identificator = int

exception LexingError of error_comment
exception ParsingError of error_comment
exception SemanticError of error_comment

exception NotImplemented of error_comment

exception Usage
exception Version
exception FileFormat


(* Printers *)

type 'a printer = Format.formatter -> 'a -> unit


(* Symbols *)

type symbol = Symbol.t

